<?

/*
 * DebugModule:
 * This module takes the debug and noop options to control the
 * debug-messages.
 * Options:
 * debug: show debug-message.
 * noop: no action (don't send mail)
 * Methods:
 *
 */
define("MOD_DEBUG",$name);

define("OPT_DEBUG",0);
define("OPT_NOOP",1);
define("OPT_LEVEL",2);

class DebugModule extends Module {
	var $name = "DebugModule";
	var $id = MOD_DEBUG;
	var $execlevel = 1;

	/* constructor */
	function DebugModule() {
		$this->options[OPT_DEBUG] = new Option("debug");
		$this->options[OPT_NOOP] = new Option("noop");
		$this->options[OPT_LEVEL] = new Option("level:debuglevel:debug-level:debug_level");

		/* call super-constructor */
		$this->Module();
	}

	function before_action() {
		global $debug;

		$this->check_options();

		if(isset($this->options[OPT_DEBUG])) {
			$debug->add_message("Option: " . $this->options[OPT_DEBUG]->name . " ". $this->options[OPT_DEBUG]->value,$this->name);
			//$switch = (is_true($this->options[OPT_DEBUG]->value)) ? false : true;
			$debug->enable(is_true($this->options[OPT_DEBUG]->value));
		}
		unset($this->options[OPT_DEBUG]);

		if(isset($this->options[OPT_NOOP])) {
			$debug->add_message("Option: " . $this->options[OPT_NOOP]->name . " ". $this->options[OPT_NOOP]->value,$this->name);
			//$switch = (is_true($this->options[OPT_NOOP]->value)) ? false : true;
			$debug->set_noop($this->options[OPT_NOOP]->value);
		}
		unset($this->options[OPT_NOOP]);

		if(isset($this->options[OPT_LEVEL])) {
			$debug->set_level($this->options[OPT_LEVEL]);
		}
		unset($this->options[OPT_LEVEL]);

	}

	function do_action() {
		$this->action();
	}

	function after_action() {
		$this->clean_up();
	}
}

$modules[$name]= new DebugModule();

