<?
/*
 * ErrorMessage:
 * This message-module creates an interface for adding error-messages and
 * aborting the other modules when an error was reported. Most of the
 * errors will be reported in one run at the end.
 */

define("MES_ERROR",$name);
define("EXIT_ACTION", 1);
define("EXIT_EXECUTION", 2); // above this errorlevel wraps up and exits

define("ERR_DEBUG",1);
define("ERR_INP_CONT",2);
define("ERR_INP_END",3);
define("ERR_CONF_CONT",4);
define("ERR_CONF_END",5);
define("ERR_DEV_CONT",6);
define("ERR_DEV_END",7);
define("ERR_CRIT_CONT",8);
define("ERR_CRIT_END",9);

$modules[$name]= new ErrorMessage;

class ErrorMessage extends Message {
	var $name = "ErrorMessage";
	var $id = MES_ERROR;

	function ErrorMessage() {
		$this->content = ERROR_CONTENT;
		$this->Message();
		$this->set_noop(false);
	}

	function message_added($errlevel,$module="",$message="") {
		global $debug;
		if ($module=="") {
			$this->error();
			if ($errlevel>EXIT_EXECUTION) {
				$this->exit_execution();
			} elseif ($errorlevel>EXIT_ACTION) {
				$debug->set_noop(true);
			}
		} else {

			switch($errlevel) {
				case ERR_DEBUG :
					$debug->add(DB_ERROR,$module,$message);
					break;
				case ERR_INP_CONT :
				case ERR_CONF_CONT :
				case ERR_DEV_CONT :
				case ERR_CRIT_CONT :
					$this->error();
					$debug->set_noop(true);
					break;
				case ERR_INP_END :
				case ERR_CONF_END :
				case ERR_DEV_END :
				case ERR_CRIT_END :
					$this->error();
					$this->exit_execution();
					break;
			}
		}
	}

	function error() {
		$this->enabled=true;
		$this->set_noop(true);
	}

	function exit_execution() {
		global $modules;
		$this->enabled = true;
		exit_fh();
	}

}


