<?

/*
 * FieldCheckModule:
 * This module checks if the input of a field matches a particular regular
 * expression.
 */

define("MOD_FIELDCHECK",$name);
define("FIELDCHECK_SEP",":");

// REGEX_MAIL is defined in module mail.
define("REGEX_URL","^((http|ftp)://)?([-a-zA-Z0-9]+\.){1,2}([a-zA-Z]{2,4})(/[a-zA-Z0-9_?&/\.]*)*$");
define("REGEX_TIME","^[0-2]?[0-9] ?[:] ?[0-5][0-9]( ?[:] ?+[0-5][0-9])$");
define("REGEX_DATE","^([0-2]?[0-9]|3[01]) ?[/-] ?(0?[0-9]|1[012]) ?[/-] ?[0-9]{1 -,4}");
define("REGEX_PHONE","^[-\+0-9\(\) ]+$"); // Worldwide accetable ?
define("REGEX_","");

$modules[$name]= new FieldCheckModule();

class FieldCheckModule extends Module {
	var $name = "FieldCheckModule";
	var $id = MOD_FIELDCHECK;
	var $execlevel = 16;
	// Default checks
	var $checks = array(
		"email"			=>REGEX_MAIL,
		"url"				=>REGEX_URL,
		"time"	=>REGEX_TIME,
		"date"	=>REGEX_DATE,
		"phone:phonenr:phonenumber"	=>REGEX_PHONE,
		"fax:faxnr:faxnumber" =>REGEX_PHONE,
		);

	function FieldCheckModule() {
		$this->Module();
	}

	function add_check($name,$regex) {
		global $debug;
		$this->checks[$name] = $regex;
		//$debug->add_message("Added check $name",$this->name);
		$debug->add(DB_XFLOW,$this->name,"Added check %s",$name);
	}

	function remove_check($check) {
		global $debug;
		// With this function it should be possible to look for string a string
		// in the keys of the checks-array and remove the checks from the keys
		// which name was found.

		//$debug->add_message("Added check $name",$this->name);
		$debug->add(DB_XFLOW,$this->name,"Removed check %s",$name);
	}

	function replace_check($check,$name,$regex) {
		$this->remove_check($check);
		$this->add_check($name,$regex);
	}
	
	function before_action() {
		global $debug;
		if (empty($this->checks)) {
			$this->disable();
			$debug->add(DB_WARN,$this->name,"No checks found, module disabled");
		}
		// No options defined, so no check needed.
		//$this->check_options();
	}

	function check_field($vars,$fieldname,$value) {
		global $debug,$error;
		if (isset($vars[$fieldname])&&!empty($vars[$fieldname])) {
			$debug->add(DB_FLOW,$this->name,"Check %s",$fieldname);
			if (!ereg($value,$vars[$fieldname])) {
				$error->add(ERR_INP_CONT,$this->name,"Field %s is not right",$fieldname);
			} // end if !strpos
		} // end if $vars
	}

	function do_action() {
		global $formHandler;
		$this->action();

		$vars = $formHandler->get_vars();
		while (list ($fieldname,$value) = each($this->checks)) {
			if (!strpos($fieldname,FIELDCHECK_SEP)===false) {
				$fieldnames = split(FIELDCHECK_SEP,$fieldname);
				while (list(,$fieldname) = each($fieldnames)) {
					$this->check_field($vars,$fieldname,$value);
				} //end while
			} else {
				$this->check_field($vars,$fieldname,$value);
			} // end if strpos
		} //end while

	}

	function after_action() {
		$this->clean_up();
	}
}

