<?
/*
 * RefererCheckModule:
 * This module checks the referer. It is possible to only accept a set of
 * forms to use the script. It is also possible to do different things with
 * different referers. Last possibility of this module is to show the form
 * that called this script with some error. The error messages can be shown
 * within the form. This can be done by adding some template-code to the
 * form. The default is that the errors are printed at the beginning or the
 * end of the form. It is usefull to use the cookie-module too, zo the
 * script can fill in the fields already entered with the cookies that are
 * set.
 */

define("MOD_REFERERCHECK",$name);

define("ALLOW",1);
define("DENY",2);
define("ALLOWFILE",3);
define("DENYFILE",4);

$modules[$name]= new RefererCheckModule();

class RefererCheckModule extends Module {
	var $name = "RefererCheckModule";
	var $id = MOD_REFERERCHECK;
	var $execlevel = 10;
	var $referer = "";
	var $allow = array();
	var $deny = array();

	function RefererCheckModule() {
		//$this->options[] = new Option("name:alias1:alias2","regular expression",required,stay_enabled_if_omitted,"default");
		$this->options[ALLOW] = new Option("allow:referer_allow");
		$this->options[DENY] = new Option("deny:referer_deny");
		$this->options[ALLOWFILE] = new Option("allowfile:referer_allowfile");
		$this->options[DENYFILE] = new Option("denyfile:referer_denyfile");
		$this->Module();
	}
	
	function before_action() {
		global $HTTP_REFERER,$debug;
		//$this->check_options();
		$this->referer=$HTTP_REFERER;
		if (empty($this->referer)) {
			$debug->add_message("No referer found; this means you use a buggy browser (IE 5?)",$this->name);
			$this->disable;
		}
	}

	function do_action() {
		global $debug,$error;
		if ($this->action()) {
			// if deny || NOT allow :
			// echo "This script is not legally configured
			//$error->add_message("",$this->name);
		}
	}

	function after_action() {
		$this->clean_up();
	}
} // end class RefererCheckModule

